<?php


namespace Ardent\PicnicApi\Objects;


class Category extends AbstractApiObject
{
    static public  function getType(): string
    {
        return 'CATEGORY';
    }

    /**
     * Category constructor.
     */
    public function __construct(
        private string $id,
        private string $name,
        private array $items,
    )
    {
    }

    static public function fromApi(array $apiObject): AbstractApiObject
    {
        return new self(
            $apiObject['id'],
            $apiObject['name'],
            ApiListTransformer::getObjects($apiObject['items']),
        );
    }

    /**
     * @return string
     */
    public function getId(): string
    {
        return $this->id;
    }

    /**
     * @return string
     */
    public function getName(): string
    {
        return $this->name;
    }

    /**
     * @return SingleArticle[]
     */
    public function getItems(): array
    {
        return $this->items;
    }
}